﻿''' <summary>
''' Hier werden Funktionen abgespeichert die standard sein sollten
''' </summary>
Public Class Ext
#Region "Encrypt/Decrypt"


    ''' <summary>
    ''' Simple Funktion um einen String mit einem Passwort zu verschlüsseln
    ''' </summary>
    ''' <param name="text">Der zu verschlüsselnde String</param>
    ''' <param name="key">Das zum verschlüsseln verwendete Passwort</param>
    ''' <returns>Den Eingabestring in verschlüsselter Form</returns>
    Public Shared Function EncryptCaesar(text As String, key As String) As String
        If key <> String.Empty Then
            Dim encrypted As String = String.Empty
            Dim keyindex As Integer = 0
            For Each c As Char In text
                Dim asciinr As Integer = Microsoft.VisualBasic.AscW(c)
                asciinr += Microsoft.VisualBasic.AscW(key(keyindex))
                If asciinr > 255 Then asciinr -= 255
                encrypted += Microsoft.VisualBasic.ChrW(asciinr)
                keyindex += 1
                If keyindex > key.Length - 1 Then keyindex = 0
            Next
            Return encrypted
        Else
            Return text
        End If
    End Function


    ''' <summary>
    ''' Simple Funktion um einen verschlüsselten String wieder zu entschlüsseln
    ''' </summary>
    ''' <param name="text">Der zu entschlüsselnde String</param>
    ''' <param name="key">Das zum verschlüsseln verwendete Passwort</param>
    ''' <returns>Den verschlüsselten Strin in entschlüsselter Form</returns>
    Public Shared Function DecryptCaesar(text As String, key As String) As String
        If key <> String.Empty Then
            Dim decrypted As String = String.Empty
            Dim keyindex As Integer = 0
            For Each c As Char In text
                Dim asciinr As Integer = Microsoft.VisualBasic.AscW(c)
                asciinr -= Microsoft.VisualBasic.AscW(key(keyindex))
                If asciinr < 0 Then asciinr = 255 + asciinr
                decrypted += Microsoft.VisualBasic.ChrW(asciinr)
                keyindex += 1
                If keyindex > key.Length - 1 Then keyindex = 0
            Next
            Return decrypted
        Else
            Return text
        End If
    End Function
#End Region

#Region "FormatBytes"


    ''' <summary>
    ''' Simple Funktion um Bytes in die entsprechende Einheit umzurechnen
    ''' </summary>
    ''' <param name="BytesCaller">Die bytes deren Einheit berechnet werden soll</param>
    ''' <param name="WithUnits">True oder False - EinheitenName in String integrieren</param>
    ''' <returns>Die Umgewandelte bytemenge</returns>
    Public Shared Function FormatBytes(ByVal BytesCaller As ULong, ByVal WithUnits As Boolean) As String
        Dim DoubleBytes As Double
        Dim ResFormatBytes As String = ""

        Select Case BytesCaller
            Case Is >= 1099511627776
                DoubleBytes = CDbl(BytesCaller / 1099511627776) 'TB
                Select Case WithUnits
                    Case True
                        ResFormatBytes = Math.Round(DoubleBytes, 2).ToString & " TB"
                    Case False
                        ResFormatBytes = Math.Round(DoubleBytes, 2).ToString
                End Select
            Case 1073741824 To 1099511627775
                DoubleBytes = CDbl(BytesCaller / 1073741824) 'GB
                Select Case WithUnits
                    Case True
                        ResFormatBytes = Math.Round(DoubleBytes, 2).ToString & " GB"
                    Case False
                        ResFormatBytes = Math.Round(DoubleBytes, 2).ToString
                End Select
            Case 1048576 To 1073741823
                DoubleBytes = CDbl(BytesCaller / 1048576) 'MB
                Select Case WithUnits
                    Case True
                        ResFormatBytes = Math.Round(DoubleBytes, 2).ToString & " MB"
                    Case False
                        ResFormatBytes = Math.Round(DoubleBytes, 2).ToString
                End Select
            Case 1024 To 1048575
                DoubleBytes = CDbl(BytesCaller / 1024) 'KB
                Select Case WithUnits
                    Case True
                        ResFormatBytes = Math.Round(DoubleBytes, 2).ToString & " kB"
                    Case False
                        ResFormatBytes = Math.Round(DoubleBytes, 2).ToString & " kB"
                End Select
            Case 0 To 1023
                DoubleBytes = BytesCaller ' bytes
                Select Case WithUnits
                    Case True
                        ResFormatBytes = Math.Round(DoubleBytes, 2).ToString & " bytes"
                    Case False
                        ResFormatBytes = Math.Round(DoubleBytes, 2).ToString
                End Select
            Case Else
                ResFormatBytes = ""
        End Select

        Return ResFormatBytes
    End Function
#End Region

#Region "Scroll to Start or End"


    ''' <summary>
    ''' Ein sehr simpler Befehl um bei beliebiger TextControl an den Anfang zu scrollen
    ''' </summary>
    ''' <param name="txtCon">Die jeweilige TextControl</param>
    Public Shared Sub ScrollToSart(ByVal txtCon As TextBoxBase)
        txtCon.SelectionStart = 0
        txtCon.ScrollToCaret()
    End Sub


    ''' <summary>
    ''' Ein sehr simpler Befehl um bei beliebiger TextControl an das Ende zu scrollen
    ''' </summary>
    ''' <param name="txtCon">Die jeweilige TextControl</param>
    Public Shared Sub ScrollToEnd(ByVal txtCon As TextBoxBase)
        txtCon.SelectionStart = txtCon.Text.Length
        txtCon.ScrollToCaret()
    End Sub
#End Region

#Region "GetExtIP"


    ''' <summary>
    ''' Holt sich die externe IP von dyndns.org
    ''' </summary>
    ''' <returns>Die aktuelle externe IP</returns>
    Public Shared Function GetExtIP() As String
        Return Regex.Replace((New WebClient()).DownloadString("http://checkip.dyndns.org"), "[^0-9\.]", "")
    End Function
#End Region

#Region "RemoveEmptyLines"


    ''' <summary>
    ''' Entfernt leere Zeilen aus der gewählten Textcontrol
    ''' </summary>
    ''' <param name="txtCon">Die jeweilige TextControl</param>
    Public Shared Sub RemoveEmptyLines(ByVal txtCon As TextBoxBase)
        txtCon.Lines = (From s As String In txtCon.Lines Where s.Trim.Length > 0 Select s).ToArray
    End Sub
#End Region

#Region "FormScreenShot"


    ''' <summary>
    ''' Erstellt einen ScreenShot der angegebenen Form
    ''' </summary>
    ''' <param name="SenderForm">Die Form von der der Screenshot erstellt werden soll</param>
    ''' <param name="Path">Pfad wo der Screenshot gespeichert werden soll</param>
    Public Shared Sub FormScreenShot(SenderForm As Form, Path As String)
        Dim FormToShot As Control
        FormToShot = SenderForm
        Dim Width As Integer = FormToShot.Width
        Dim Height As Integer = FormToShot.Height
        Dim Shot As Bitmap = New Bitmap(Width, Height)
        FormToShot.DrawToBitmap(Shot, Rectangle.FromLTRB(0, 0, Width, Height))
        Shot.Save(Path, Imaging.ImageFormat.Bmp)
    End Sub
#End Region

#Region "TimeForFiles"


    ''' <summary>
    ''' Die aktuelle Zeit passen formatiert um in Dateinamen verwendet zu werden
    ''' </summary>
    ''' <returns>DateTimeNow passen formatiert um in Dateinamen verwendet zu werden</returns>
    Public Shared Function TimeForFiles() As String
        Return " " & Regex.Replace(Regex.Replace(DateTime.Now.ToString, ":", "-"), " ", "---")
    End Function
#End Region

#Region "CreateShortcut"


    ''' <summary>
    ''' Erstellt eine Verknüpfung am gewählten ZielOrt, von der gewählten Datei
    ''' </summary>
    ''' <param name="SourceFile">Der Pfad der Datei von der eine Verknüpfung erstellt werden soll als String</param>
    ''' <param name="TargetFolder">Der ZielOrdner z.B. Desktop als String</param>
    ''' <param name="TargetFileName">Der Name der neuen Verknüpfung als String</param>
    ''' <param name="sArguments">Wenn gewünscht auch Parameter als String</param>
    ''' <param name="sWorkingDir">Wenn gewünscht ein eigenes WorkingDir als String</param>
    ''' <param name="sDescription">Wenn gewünscht auch eine Beschreibung als String</param>
    ''' <param name="sIconPath">Wenn ein eigenes Icon gewünscht dessen Pfad als String</param>
    Public Shared Sub CreateShortcut(ByVal SourceFile As String, ByVal TargetFolder As String, ByVal TargetFileName As String,
                                     Optional ByVal sArguments As String = "", Optional ByVal sWorkingDir As String = "",
                                     Optional ByVal sDescription As String = "", Optional ByVal sIconPath As String = "")

        Dim lnkFilename As String = TargetFolder & "\" & TargetFileName & ".lnk"

        If Not IO.File.Exists(lnkFilename) Then
            Dim wsh As New IWshRuntimeLibrary.WshShell()
            Dim lnk As IWshRuntimeLibrary.IWshShortcut = DirectCast(wsh.CreateShortcut(lnkFilename), IWshRuntimeLibrary.IWshShortcut)

            lnk.TargetPath = SourceFile

            If sArguments.Length > 0 Then lnk.Arguments = sArguments
            If sWorkingDir.Length > 0 Then lnk.WorkingDirectory = sWorkingDir
            If sDescription.Length > 0 Then lnk.Description = sDescription
            If sIconPath.Length > 0 Then lnk.IconLocation = sIconPath

            lnk.Save()
        Else
            MessageBox.Show("Diese Verknüpfung existiert bereits!", "Info")
        End If

    End Sub
#End Region

#Region "WaitForPageLoad"
    Private Property pageready As Boolean = False


    ''' <summary>
    ''' Lässt das Programm warten bis der jeweilige Browser fertig geladen hat
    ''' </summary>
    ''' <param name="Bro">Der jeweilige Browser der Warten soll</param>
    Public Sub WaitForPageLoad(ByVal Bro As WebBrowser)
        AddHandler Bro.DocumentCompleted, New WebBrowserDocumentCompletedEventHandler(Sub() PageWaiter(Bro))
        While Not pageready
            Application.DoEvents()
        End While
        pageready = False
    End Sub

    Private Sub PageWaiter(ByVal Bro As WebBrowser)
        If Bro.ReadyState = WebBrowserReadyState.Complete Then
            pageready = True
            RemoveHandler Bro.DocumentCompleted, New WebBrowserDocumentCompletedEventHandler(Sub() PageWaiter(Bro))
        End If
    End Sub
#End Region

#Region "ReduceRam"
    <DllImport("kernel32.dll")>
    Private Shared Function SetProcessWorkingSetSize(hProcess As IntPtr, dwMinimumWorkingSetSize As Integer, dwMaximumWorkingSetSize As Integer) As Boolean
    End Function

    ''' <summary>
    ''' Entfernt nicht mehr benötigte Daten effizient aus dem RAM
    ''' </summary>
    Public Shared Sub ReduceRam()
        ReduceMemoryUsage()
    End Sub

    Private Shared Sub ReduceMemoryUsage()
        Try
            GC.Collect()
            GC.WaitForPendingFinalizers()
            If Environment.OSVersion.Platform = PlatformID.Win32NT Then
                SetProcessWorkingSetSize(Process.GetCurrentProcess().Handle, -1, -1)
            End If
        Catch
        End Try
    End Sub
#End Region

#Region "Resolution"


    ''' <summary>
    ''' Simple Funktion um einen String mit der Auflösung zu erhalten
    ''' </summary>
    ''' <param name="ChoosenScreen">PrimaryScreen oder Alle Screens</param>
    ''' <param name="WorkResolution">Ob die taskleiste abgezogen werden soll</param>
    ''' <returns>Die aktuelle Auflösung</returns>
    Public Shared Function Resolution(ChoosenScreen As Screen, WorkResolution As Boolean) As String
        Select Case WorkResolution
            Case = True
                Return ChoosenScreen.WorkingArea.Width & "x" & ChoosenScreen.WorkingArea.Height
            Case = False
                Return ChoosenScreen.Bounds.Width & "x" & ChoosenScreen.Bounds.Height
            Case Else
                Return "0x0"
        End Select
    End Function
#End Region
End Class